// Cave Data
//Proteus 1935
#ifdef EDITOR
//double PLAYER_START[2];
//double PLAYER_FINISH[2];
#endif
void Set_Ground_Level(short int level)
{
 
 for(int t=0;t<MAX_LEVEL_LENGTH;t++)
     {
         GROUND[t]= level;
         CEIL[t] = 0;
     
     }
     
     CAMERA_POSITION = 0;
     LEVEL_ENDING = MAX_LEVEL_LENGTH - 1024;
}

//Draw cave


void Draw_Ground(BITMAP *bmp)
{
      if(CAMERA_POSITION < 0)CAMERA_POSITION=0;
     
     #ifdef GAME
     if(CAMERA_POSITION >= LEVEL_ENDING)CAMERA_POSITION = LEVEL_ENDING;
    
     #endif
     #ifdef EDITOR
     if(CAMERA_POSITION >= MAX_LEVEL_LENGTH-1024)CAMERA_POSITION = MAX_LEVEL_LENGTH-1024;
     
     if(CAMERA_POSITION < LEVEL_ENDING)
         {
                        if(CAMERA_POSITION + 1024 > LEVEL_ENDING)
                             {
                                
                             sketch_lines(bmp,LEVEL_ENDING - CAMERA_POSITION,0,LEVEL_ENDING - CAMERA_POSITION,SCREEN_H,2);    
                                    
                             }
         }//eoSHOW END
     #endif
     
     for(int t=0;t< 1024;t++)
     {
       sketch_lines(bmp,t,GROUND[t+CAMERA_POSITION],t+5,GROUND[t+5+CAMERA_POSITION],1);
     }
     
     #ifdef EDITOR

     #endif
     
}

void Draw_CEIL(BITMAP *bmp)
{
     
     for(int t=0;t< 1024;t++)
     {
       sketch_lines(bmp,t,CEIL[t+CAMERA_POSITION],t+5,CEIL[t+5+CAMERA_POSITION],1);
     }
     
     
}


int SELECTED_MODE;


#define PIXEL 0
#define LINE 1
#define EOFmap 3
#define NMEDIT 4
#define WAYPOINTEDIT 5
#define PLAYEREDIT 6
#define TEXTEVENT 7
int edOldX,edOldY;
int edX,edY;

//Sim eu deveria ter feito um array , implantado Inlines com scancodes e td mais...
// Mas eu quero acabar ainda esse ms :D

int keysw1;
int keysw2;
int keysw3;
int keysw4;
 void GROUND_LINE(BITMAP *bmp, int x, int y, int d)
      {
         GROUND[x + CAMERA_POSITION] = y;
      }

 void CEIL_LINE(BITMAP *bmp, int x, int y, int d)
      {
         CEIL[x + CAMERA_POSITION] = y;
      }
//LEVEL EDITOR's Main function
#ifdef EDITOR
int gnme_on_screen(ground_nme * nme);



void Edit_Level(BITMAP * bmp)
{
     
     double size_correction;
     char SelectS[64];
     
     switch(SELECTED_MODE)
     {
     
              case PIXEL:
              
                   if( mouse_b & 1)
                   GROUND[CAMERA_POSITION + mouse_x] = mouse_y;
                   
                   if( mouse_b & 2)
                   CEIL[CAMERA_POSITION + mouse_x] = mouse_y;
               
              break;
         
              case LINE:

               edOldX = edX;edOldY = edY;
               edX = mouse_x; edY = mouse_y;   
               if(mouse_b & 1)
                {
                 do_line(NULL, edOldX, edOldY,edX, edY,0,GROUND_LINE);       
                }
               if(mouse_b & 2)
               {
                 do_line(NULL, edOldX, edOldY,edX, edY,0,CEIL_LINE);           
               }
              break;
              //Fim do mapa (camera no ultrapassara essa marca!)
              case EOFmap:
                   
                   if(mouse_b & 1)
                   {
                     LEVEL_ENDING = CAMERA_POSITION + mouse_x;
                     if(LEVEL_ENDING > MAX_LEVEL_LENGTH )
                     {
                                     LEVEL_ENDING =MAX_LEVEL_LENGTH;
                                     allegro_message("Map waaaay too big!");
                     }
                   }
              break;
              //Select & Place NMEs
              case NMEDIT:
                   #define INIMI GROUND_NMES_DATABASE[SELECTED_GNME_TYPE]
                   #define INIMIDEST GROUND_NMES[SELECTED_GNME]
                   if( key_event(KEY_DOWN))SELECTED_GNME_TYPE ++;    
                   if( key_event(KEY_UP))SELECTED_GNME_TYPE --;
                   if( key_event(KEY_DEL))INIMIDEST.alive=false;                     
                   if(key_event(KEY_LEFT))SELECTED_GNME --;
                   if(key_event(KEY_RIGHT))SELECTED_GNME ++; 
                   
                   if(key_event(KEY_END))
                   {
                                         if(  INIMIDEST.istarget == false )
                                         {
                                              INIMIDEST.istarget = true;
                                         }else{
                                               INIMIDEST.istarget = false; 
                                         }
                   
                  
                   }               
                   if(SELECTED_GNME_TYPE <0)SELECTED_GNME_TYPE=0;
                   if(SELECTED_GNME_TYPE > LAST_NME)SELECTED_GNME_TYPE = LAST_NME;
                   if(SELECTED_GNME <0)SELECTED_GNME=0;
                   if(SELECTED_GNME > MAX_G_NMES-1)SELECTED_GNME = MAX_G_NMES-1;
 
                   //Placing & replacing
                   if(mouse_b & 1)
                   {
                          if(!mouse_in_rect(SCREEN_W - 300,100,SCREEN_W-20,400)) 
                          {
                           //Replace current NME with current type selection                                                 
                          
                          copy_ground_nme(&INIMI,&INIMIDEST);
                          INIMIDEST.position = CAMERA_POSITION + mouse_x;
                          }    
                   }
                   
                   //Graph
                   rectfill(bmp, SCREEN_W - 300, 100, SCREEN_W-20,400,makecol(255,255,255));
                   rect(bmp, SCREEN_W - 300, 100, SCREEN_W-20,400,makecol(0,0,0));

                   size_correction = 100.0/(INIMI.graph.minradius);
                   
                   sketch_shape_inv_size(bmp,&INIMI.graph,(SCREEN_W -160),250,size_correction);
                  
                   //sketch currently selected enemy
                   sketch_text(bmp,testfont,(char*)INIMI.name.data()  ,SCREEN_W - 299 ,101);
                    SelectS[64];
                   sprintf( SelectS, "NME#: %d ", SELECTED_GNME );
                   
                   sketch_text(bmp,testfont, SelectS ,SCREEN_W - 299 ,350);
                   
                   if(INIMIDEST.istarget)
                   {
                     sketch_text(bmp,testfont, "Is Objective" ,SCREEN_W - 299 ,310);
                   }
                   
                   if( gnme_on_screen(&INIMIDEST) )
                   {
                         sketch_circles(bmp,(int)(INIMIDEST.position - CAMERA_POSITION) ,(int)GROUND[(int)(INIMIDEST.position - CAMERA_POSITION)],(int)INIMIDEST.graph.minradius,1);
                                                
                   }
                   
                   
                   #undef INIMI
                   #undef INIMIDEST
              break;
              
              //Select & Place NMEs
              case WAYPOINTEDIT:
                   
                   #define INIMIDEST GROUND_NMES[SELECTED_GNME]
                   if( key_event(KEY_DOWN))SELECTED_WAYPOINT --;    
                   if( key_event(KEY_UP))SELECTED_WAYPOINT ++;
                   if( key_event(KEY_DEL))INIMIDEST.alive=false;                     
                   if(key_event(KEY_LEFT))SELECTED_GNME --;
                   if(key_event(KEY_RIGHT))SELECTED_GNME ++; 
                     
                   
                   if(SELECTED_WAYPOINT <0)SELECTED_WAYPOINT=0;
                   if(SELECTED_WAYPOINT > MAX_WAYPOINTS -1)SELECTED_WAYPOINT = MAX_WAYPOINTS-1;
                   if(SELECTED_GNME <0)SELECTED_GNME=0;
                   if(SELECTED_GNME > MAX_G_NMES-1)SELECTED_GNME = MAX_G_NMES-1;
                   
                   //Graph
                   rectfill(bmp, SCREEN_W - 300, 100, SCREEN_W-20,400,makecol(255,255,255));
                   rect(bmp, SCREEN_W - 300, 100, SCREEN_W-20,400,makecol(0,0,0));

                   size_correction = 100.0/(INIMIDEST.graph.minradius);
                   
                   sketch_shape_inv_size(bmp,&INIMIDEST.graph,(SCREEN_W -160),250,size_correction);
                    SelectS[64];
                   sprintf( SelectS, "NME#: %d ", SELECTED_GNME );
                   sketch_text(bmp,testfont, SelectS ,SCREEN_W - 299 ,350);
                   sprintf( SelectS, "WAY#: %d ", SELECTED_WAYPOINT );
                   sketch_text(bmp,testfont, SelectS ,SCREEN_W - 299 ,300);
                                      //Placing & replacing
                   if(mouse_b & 1)
                   {
                          if(!mouse_in_rect(SCREEN_W - 300,100,SCREEN_W-20,400)) 
                          {
                           //Replace current NME with current type selection                                                 
                          
                           INIMIDEST.waypoints[SELECTED_WAYPOINT].px = CAMERA_POSITION + mouse_x;
                          }    
                   }
                   
                   for(int t = 0;t< MAX_WAYPOINTS;t++)
                   {
                            if(position_on_screen(INIMIDEST.waypoints[t].px) && INIMIDEST.waypoints[t].px>0)
                            {
                              sprintf( SelectS, "W%d", t );
                              center_sketch_text(bmp,testfont, SelectS ,(int)(INIMIDEST.waypoints[t].px - CAMERA_POSITION ), GROUND[(int)INIMIDEST.waypoints[t].px] );
                            }      
                           
                   }
                  
                   if( gnme_on_screen(&INIMIDEST) )
                   {
                         sketch_circles(bmp,(int)(INIMIDEST.position - CAMERA_POSITION) ,(int)GROUND[(int)(INIMIDEST.position - CAMERA_POSITION)],(int)INIMIDEST.graph.minradius,1);
                                                
                   }
                   
                   
                   #undef INIMIDEST
              break;
              
              case PLAYEREDIT:
                   
                   if(mouse_b &1)
                   {
                   PLAYER_START[0] = mouse_x + CAMERA_POSITION;
                   PLAYER_START[1] = mouse_y ;        
                   }
                   if(mouse_b &2)
                   {
                     PLAYER_FINISH[0] = mouse_x + CAMERA_POSITION;
                     PLAYER_FINISH[1] = mouse_y ;          
                   }
                   
                   if(position_on_screen(PLAYER_START[0]))
                   {
                      center_sketch_text(bmp,testfont,"Player Start",(int)(PLAYER_START[0] - CAMERA_POSITION),(int)PLAYER_START[1]);
                      sketch_circles(bmp,(int)(PLAYER_START[0] - CAMERA_POSITION),(int)PLAYER_START[1],10,1);                                      
                   }
                   if(position_on_screen(PLAYER_FINISH[0]))
                   {
                      center_sketch_text(bmp,testfont,"Player Goal",(int)(PLAYER_FINISH[0] - CAMERA_POSITION),(int)PLAYER_FINISH[1]);
                      sketch_circles(bmp,(int)(PLAYER_FINISH[0] - CAMERA_POSITION),(int)PLAYER_FINISH[1],10,10);                                      
                   }                  
                   
              break;
              
              case TEXTEVENT:
                    #define EVENT TEVENTS[CURRENT_TEVENT]
                   if( key_event(KEY_DOWN))CURRENT_TEVENT --;    
                   if( key_event(KEY_UP))CURRENT_TEVENT ++;
                   if( key_event(KEY_DEL))EVENT.active=false;                     


                     
                   
                   if(CURRENT_TEVENT <0)CURRENT_TEVENT=0;
                   if(CURRENT_TEVENT > TEVENT_MAX -1)CURRENT_TEVENT = TEVENT_MAX-1;
                                      
                   //Graph
                   rectfill(bmp, SCREEN_W - 300, 100, SCREEN_W-20,400,makecol(255,255,255));
                   rect(bmp, SCREEN_W - 300, 100, SCREEN_W-20,400,makecol(0,0,0));

                                     
                   sprintf( SelectS, "Text Event#: %d ", CURRENT_TEVENT );
                   sketch_text(bmp,testfont, SelectS ,SCREEN_W - 299 ,350);
                   
                   if(mouse_b & 1)
                   {
                   EVENT.active = true;
                   EVENT.position = mouse_x + CAMERA_POSITION;           
                   EVENT.py = mouse_y;           
                   } 
                   char CARAC='D';
                   int CARAC_CURSOR=0;
                   if(mouse_b & 2)
                   {
                        clear_keybuf();
                        while(CARAC != 13)
                        {
                        CARAC = (char)readkey();
                        //allegro_message("%d",CARAC);
                        EVENT.string[CARAC_CURSOR] =CARAC;
                        
                        CARAC_CURSOR++; 
                        if(CARAC_CURSOR > 253)break;
                        }
                        
                        EVENT.string[CARAC_CURSOR-1] =0;
                              
                   }                
                   
                   #undef EVENT
              break;
              
     }
     

}//EOF LEVEL EDITOR's MAIN
#endif
//Anotando coisas em meio ao cdigo chatico
//panasonic s35
//------------------------------------------------------------------

void camera_control()
{
     
     if(key[KEY_6_PAD])CAMERA_POSITION+=20;
     if(key[KEY_4_PAD])CAMERA_POSITION-=20;
     
}
//Funes de SAVE/LOAD GAMBIARRA com a ZLIB
void save_map()
{
     fstream save_file;
     save_file.open("map.skm", ios::binary| ios::out);
     
     save_file.write((char*)&LEVEL_ENDING,sizeof(int));
     
     
for(int t = 0 ; t < LEVEL_ENDING+1024; t++)
        {
          save_file.write((char*)&GROUND[t],sizeof(short int));
          save_file.write((char*)&CEIL[t],sizeof(short int));
        }
     
     //GNME NAME ARRAY
     char buffer[16];
     int numberofgnmes=0;
     for(int t =0; t < MAX_G_NMES;t++)
     {
      if( GROUND_NMES[t].alive) numberofgnmes++;
     }
     //Nmero de inimigos
     save_file.write((char*)&numberofgnmes,sizeof(int));
     
     for(int t =0; t < MAX_G_NMES;t++)
     {

           if( GROUND_NMES[t].alive)
           {
                //Gravar Numero
            save_file.write((char*)&t,sizeof(int));
                //Gravar Posio X
            save_file.write((char*)&GROUND_NMES[t].position,sizeof(double));    
                //Gravar nome  APENAS 8 CHARS!   GROUND_NMES[MAX_G_NMES]    
            save_file.write((char*)GROUND_NMES[t].name.data(),8);
                //Gravar Waypoints                                                  
            save_file.write((char*)GROUND_NMES[t].waypoints,sizeof(Waypoint)*MAX_WAYPOINTS);
                //Gravar Se  objetivo
            save_file.write((char*)&GROUND_NMES[t].istarget,sizeof(bool));    
           }  
     }
      
     //Player positions
     save_file.write((char*)PLAYER_START,sizeof(double)*2);
     save_file.write((char*)PLAYER_FINISH,sizeof(double)*2);        
     
     //Text

     int numberoftevents=0;
     for(int t =0; t < MAX_G_NMES;t++)
     {
      if( TEVENTS[t].active) numberoftevents++;
     }
     //Nmero de tevents
     save_file.write((char*)&numberoftevents,sizeof(int));
     
          for(int t =0; t < TEVENT_MAX;t++)
     {

           if( TEVENTS[t].active)
           {
                //Gravar Numero
            save_file.write((char*)&t,sizeof(int));
                //Gravar Posio X
            save_file.write((char*)&TEVENTS[t].position,sizeof(double));    
                //Gravar Py  
            save_file.write((char*)&TEVENTS[t].py,sizeof(double));
                //Gravar String
            save_file.write((char*)TEVENTS[t].string,sizeof(char)*256);
            
           }  
     }
     
     
     
     
     save_file.close();     

     FILE * compress  = fopen("map.skm","rb+");
     FILE *compressed = fopen("map.zkm","wb+");
     def(compress, compressed, Z_DEFAULT_COMPRESSION);
     
     fclose(compress);
     fclose(compressed);     
     remove("map.skm");
}
//Prottipos requeridos
void create_genemy_game(string name,double position,int pathable,int index);


void load_map(string mapath)
{
     
     
     
     
     Set_Ground_Level(600);
 MISSION_COMPLETE =999;
 SHOTS_FIRED = 0;
 BOMBS_FIRED = 0;

 NME_KILLS = 0;
     
     FILE * compress  = fopen("map.skm","wb+");
     FILE *compressed = fopen(mapath.data(),"rb+");
    // def(compress, compressed, Z_DEFAULT_COMPRESSION);
     inf(compressed,compress);
     fclose(compress);
     fclose(compressed); 
     
     
     fstream load_file("map.skm",ios_base::binary | ios_base::in);
     load_file.read((char*)&LEVEL_ENDING,sizeof(int));
     
    // allegro_message("%d",LEVEL_ENDING);
for(int t = 0 ; t < LEVEL_ENDING+1024; t++)
        {
          load_file.read((char*)&GROUND[t],sizeof(short int) );
          load_file.read((char*)&CEIL[t],sizeof(short int) );
        }
     
     //GNME NAME ARRAY
     
     char buffer[16];int gnmeindex;double tempx;
     int numberofgnmes; load_file.read((char*)&numberofgnmes,sizeof( int) );
     //allegro_message("Number of gnmes = %d", numberofgnmes);
     for(int t =0; t < numberofgnmes;t++)
     {
             
                //Carregar Numero
            load_file.read((char*)&gnmeindex,sizeof( int) );
          
            load_file.read((char*)&tempx,sizeof(double));
            
                       
                //Carregar nome  APENAS 8 CHARS!   GROUND_NMES[MAX_G_NMES]    
            load_file.read((char*)buffer,8);buffer[8]= '\0';
            
            
            
            string name; name = buffer;
                //Carregar NME
            create_genemy_game(name,tempx,true,gnmeindex);
            GROUND_NMES[gnmeindex].alive = true;
                //Carregar Waypoints no lugar certo
            load_file.read((char*)GROUND_NMES[gnmeindex].waypoints,sizeof(Waypoint)*MAX_WAYPOINTS);
                //Carregar A informao de objetivo
            load_file.read((char*)&GROUND_NMES[gnmeindex].istarget,sizeof(bool));    
            
           // allegro_message("NME %s NB %d @ position %f, Carregado %d",buffer, gnmeindex, tempx, GROUND_NMES[gnmeindex].armed) ;
             
     }
      
           //Player positions
     load_file.read((char*)PLAYER_START,sizeof(double)*2);
     load_file.read((char*)PLAYER_FINISH,sizeof(double)*2);    
     player.px = PLAYER_START[0];
     player.py = PLAYER_START[1];
     player.angle = -pi/2.0;
     //Text Events
     deactivate_tevents();
     int numberoftevents;
     int teventnb;
          //Nmero de tevents
     load_file.read((char*)&numberoftevents,sizeof(int));
     
          for(int t =0; t < numberoftevents;t++)
     {

           
           
                //Gravar Numero
            load_file.read((char*)&teventnb,sizeof(int));
             TEVENTS[teventnb].active = true;
                //Gravar Posio X
            load_file.read((char*)&TEVENTS[teventnb].position,sizeof(double));    
                //Gravar Py  
            load_file.read((char*)&TEVENTS[teventnb].py,sizeof(double));
                //Gravar String
            load_file.read((char*)TEVENTS[teventnb].string,sizeof(char)*256);
            
             
     }
     
     
        
     load_file.close();     
     remove("map.skm");
}

void load_map()
{
     string mapath("map.zkm");
     load_map( mapath);
}
