//Load Wiredata

#define MAX_VERTS 50
#define MAX_BULLETS 50
struct Particle
{
       int life;
       double px,py;
       double vx,vy;
};


#define particle_chaos 2
void spaw_particle(Particle * part, double x, double y,double vx,double vy, int life)
{
     part->life = life;
     part->px = x;
     part->py = y;
     part->vx=vx + vx*(rand()%particle_chaos)/10.0;
     part->vy=vy + vx*(rand()%particle_chaos)/10.0 ;
}


void sketch_lines(BITMAP *bmp, int x1,int y1,int x2 , int y2,int linb);

void draw_particles(Particle * part,int pnb)
{
 for(int t =0;t< pnb;t++)
         {
            if(part[t].life > 0)
            {
            if(part[t].py > GROUND[(int)part[t].px])
            {
                   // part[t].life /=2;
                    part[t].vy *= -0.75;
                    part[t].vx *= ((rand()%3)-6 )/2.0    ;   
            }
            part[t].life --;
            part[t].px += part[t].vx;
            part[t].py += part[t].vy;
            part[t].vy -=  GRAV;
            
            if(part[t].px > CAMERA_POSITION)
            if(part[t].px < CAMERA_POSITION + SCREEN_W)
            sketch_lines(BACKBUFFER,(int)part[t].px - CAMERA_POSITION,(int)part[t].py,(int)(part[t].px-part[t].vx - CAMERA_POSITION),(int)(part[t].py-part[t]. vy),2);
            
            }
         }     
}
#define MAX_T_PARTICLES 100


struct Shape
{
       int vertnb;
       double X[MAX_VERTS];
       double Y[MAX_VERTS];
       double CX[MAX_VERTS];
       double CY[MAX_VERTS];  

       double bbxmin,bbymin;
       double bbxmax,bbymax;
       double minradius;
       double minradius2;
       bool mirror;
};

//Calcular o retangulo e raio mnimo

void calculate_shape_collision_data(Shape *shape)
{
     shape->mirror = false;
     shape->bbxmin = 0;shape->bbymin=0;
     shape->bbxmax = 0;shape->bbymax=0;
     shape->minradius2 = 0;
    for(int t = 0 ; t< shape->vertnb;t++)
    {
            
      if( shape->minradius2 <  (shape->X[t]*shape->X[t] + shape->Y[t]*shape->Y[t]) )shape->minradius2 = (shape->X[t]*shape->X[t] + shape->Y[t]*shape->Y[t]);
      
      if( shape->X[t] < shape->bbxmin)shape->bbxmin = shape->X[t];
      if( shape->X[t] > shape->bbxmax)shape->bbxmax = shape->X[t];
      if( shape->Y[t] < shape->bbymin)shape->bbymin = shape->Y[t];
      if( shape->Y[t] > shape->bbymax)shape->bbymax = shape->Y[t];             
            
    }
    shape->minradius = sqrt(shape->minradius2);
    //allegro_message("%f %f %f %f",shape->bbxmin,shape->bbxmax,shape->bbymin,shape->bbymax);
    //allegro_message("minimum radius squared: %f , minimum radius %f",shape->minradius2,shape->minradius); 
}

//Coliso RAPIDA de bounding boxes vs. pto
int calculate_shape_bbcollision(double tx, double ty, double x,double y, Shape * s)
{
   if( tx < (s->bbxmin +x) )return 0; 
   if( ty < (-s->bbymax +y) )return 0;
   if( tx > (s->bbxmax +x) )return 0;
   if( ty > (-s->bbymin +y) )return 0;

   //allegro_message("Collision Occured");
   return 1;
}


struct Ship
{
       bool alive;
      // int vertnb;
       Shape graph;
       //double X[MAX_VERTS];
       //double Y[MAX_VERTS];

       //double CX[MAX_VERTS];
       //double CY[MAX_VERTS];
       double angle;
       double px,py;
       double vx,vy;
       double ax,ay;
       double mass;
       double tx,ty;
       int cpnb;
       int mpnb;
       Particle tparticles[MAX_T_PARTICLES];
       double life;
       double energy;//Energia para tiros
       double menergy;
       double recoverate;
       double MGUN_PERCENTAGE;
       double BOMB_PERCENTAGE;
       double MGUN_PERCENTAGE_MAX;
       double BOMB_PERCENTAGE_MAX;       
       
      
};




void thrust_ship(Ship *target,double dir);




//--------------------------------------------------------------------
	using namespace std; // Sim eu fao gambiarras p/ me divertir
	                     
//--------------------------------------------------------------------    
    string read_uncommented(fstream* sr)
	{
		string temp;
		char tempc[1024];
		
		while( !sr->eof() )
		{
			sr->getline(&tempc[0],1024,'\n');
			temp = tempc;
			if( temp.find("//",0)!= 0 )break;
			//if(index != 0)break;

		}
		return temp;
	}
//--------------------------------------------------------------------
int Load_WireData(int *vertnb,double X[MAX_VERTS], double Y[MAX_VERTS],string name)
{
           	string linha;
           	#define LINHAC (char*)linha.data()
           	
            name += "mesh.2d";
           	//Open Stream
            fstream wire_file((char*)name.data());
           	//allegro_message((char*)name.data());

           	if(!wire_file)return 1;
           	
           	linha = read_uncommented(&wire_file);
            *vertnb = atoi(LINHAC);
            //debug
            
            
           // allegro_message( "%d", *vertnb );
           	//go on
           	if(*vertnb >= MAX_VERTS)return 1;
           	
           	for(int t = 0 ; t < *vertnb;t++)
               {
                    
               linha = read_uncommented(&wire_file);
               X[t] = atof(LINHAC);
               linha = read_uncommented(&wire_file);
               Y[t] = atof(LINHAC);
               
               }
           	
           	X[*vertnb] = X[0]; Y[*vertnb] = Y[0];// Aplicando uma moldura unidimnsional =] bonitinho o nome dessa gambiarra
           	
           	
           	//Close Stream
           	wire_file.close();
           	
           	return 0;
     
}


void Load_Shape(Shape *dest,string name)
{
            string path("wiredata\\Shapes\\");
            path += (name+"\\");
            Load_WireData(&dest->vertnb,dest->X,dest->Y,path);
            Load_WireData(&dest->vertnb,dest->CX,dest->CY,path);
            
            
}

void Load_Ship(Ship *dest, string name)
{

        string path("wiredata\\ships\\");
		path += (name+"\\");
		Load_WireData(&dest->graph.vertnb,dest->graph.X,dest->graph.Y,path);
        Load_WireData(&dest->graph.vertnb,dest->graph.CX,dest->graph.CY,path);
               
        calculate_shape_collision_data(&dest->graph);
        
        dest->px = 100;
        dest->py = 200;
        dest->angle = 0;
        dest->mass = 10;

        dest->tx = 0;dest->ty = 0;
        dest->ax = 0;dest->ay = 0;
        dest->vx = 0;dest->vy = 0;
        dest->life = 1000;
        
        dest->energy = 100;
        dest->menergy =100;
        dest->recoverate = 0.001;
        
        dest->cpnb = 0;
        dest->mpnb = 50;
        dest->alive = true;
        
        for(int t = 0; t< MAX_T_PARTICLES; t++)
        {
        dest->tparticles[t].life = 0;        
                
        }
} 


